

package DockFloatDemo;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.plaf.basic.BasicComboPopup;
import javax.swing.border.*;
import javax.swing.plaf.basic.*; 

import dsx.JDockFloatPro.*;


public class MDIDemo
{  public static void main(String[] args)
   {  
	  DesktopFrame frame = new DesktopFrame();
          
	  frame.LoadDockFloatStates("MdiMyFile.tmp");  // Load previous Dock/Float States

         
         frame.initww();          
       
    
          frame.show();  
          frame.validate();
            frame.setSize(500,400);  
 
 
   }
}

// derive class from dsx.JDockFloatPro.DockFloatFrame
class DesktopFrame extends dsx.JDockFloatPro.DockFloatFrame
           implements ActionListener//, VetoableChangeListener
{  
  

   public DesktopFrame()
   {
       super(); 
	   setBackground(SystemColor.menu);

  	   // Force SwingSet to come up in the Cross Platform L&F
		try 
		{
			//	UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
				// If you want the System L&F instead, comment out the above line and
				// uncomment the following:
			   UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception exc) 
		{
				System.err.println("Error loading L&F: " + exc);
		}

	   dfTabWindow=new dsx.JDockFloatPro.DockFloatToolBar(this,"Tabbed Window")
	   {
	        // override getPreferredSize of DockFloatToolBar to get customized size 
	        protected Dimension getPreferredSize(int iDockStyle)
			{
			    Dimension d=new Dimension();
				d.width=500;
				d.height=50;
				return d;
			}
	   };
           
           
             addWindowListener(new WindowAdapter()
       {  
			public void windowClosing(WindowEvent e)
            { 
                SaveDockFloatStates("MdiMyFile.tmp"); // save dock and float states
				System.exit(0);
            }
       } );

          
     setBackground(SystemColor.menu); 
 	 setDragAreaStyle(DRAGHANDLE);      // set drag area be no caption style

      
   }

   public void initww()
   {
   
      setTitle("MDI Dock/Float Window Demo");
  
     desktop = new JDesktopPane();
          Component comp=desktop; 
          
          JScrollPane sp = new JScrollPane(desktop);
          
  
         
         
     super.addFixedComponent(sp,BorderLayout.CENTER); // set desktop as the center pane
       
 
        
     createDockFloatMenu();  // create Dock/Float menu window
	 createDockFloatTabWindow();   // create Dock/Float toolbar that contains a tabbed panel

     
	 createDockFloatTreeWindow();  // create Dock/Float window that contains JTree


     createDockFloatTextAreaWindow(); // create Dock/Float window that has contains JTextArea


   }

   private void createDockFloatTextAreaWindow()
   {
	  dfTextAreaWindow= new dsx.JDockFloatPro.DockFloatWindow(this,"Debug Window");
	  dfTextAreaWindow.setSize(300,200);

      JTextArea jBo=new JTextArea();
	  jBo.setEditable(false);
	  jBo.setLineWrap(true);
	  jBo.setWrapStyleWord(true);
	  JScrollPane scr=new JScrollPane(jBo);
	  scr.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);


	  String stext="This demo shows you a Dock/Float window that contains a JTree component, aDock/Float window that contains a JTextArea component,"+
	               " a Dock/Float menu bar and a customized Dock/Float tool bar that contains JTabbedPanel."+
				   "  The demo also shows you how to integrate Dock/Float components with JInternalFrame.  "+
				   "Just click File from menu bar and click Open in the sub menu to open a htm file. "+
				   " You can open multiple files.   When the position of a Dock/Float component is changed, the "+
				   " MDI panels will be automatically adjusted.     "+
	               " The source file for this demo is MDIDemo.java";
	  jBo.setText(stext);
		  
	  dfTextAreaWindow.add("Center", scr);
	
	  dfTextAreaWindow.initStates(1);
   }

   private void createDockFloatTabWindow()
   {
        JToolBar toolbar = new JToolBar();
		JTabbedPane tabpane=new JTabbedPane(JTabbedPane.BOTTOM);
                tabpane.setPreferredSize(new Dimension(300,50));
		tabpane.add("Tab1",new JButton("Add"));
		tabpane.add("Tab2",new JLabel("Label"));
		tabpane.add("Tab3",new JButton("Delete"));
		toolbar.add(tabpane);


            dfTabWindow.setToolBar(toolbar);   // set JToolBar
        
		dfTabWindow.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));

		dfTabWindow.initStates(DockFloatWindow.DOCKTOP);  // init states
          	    dfTabWindow.setDockableMask(DockFloatWindow.DOCKTOPMASK|DockFloatWindow.DOCKBOTTOMMASK); // only allow horizontal docking      
   }

   private void createDockFloatMenu()
   {
	   menuBar = new JMenuBar();

	   dsx.JDockFloatPro.DockFloatMenuBar f=new dsx.JDockFloatPro.DockFloatMenuBar(this,"Menu Bar")
	   {
	       protected boolean hasHiddenArea()
		   {
		       return false;
		   }
	   };
           
      ///    m_dfMenu = f;

	   f.setDockableMask(DockFloatWindow.DOCKTOPMASK|DockFloatWindow.DOCKBOTTOMMASK);
	 
      JMenu fileMenu = new JMenu("File");

	  fileMenu.setMnemonic (KeyEvent.VK_F);
      menuBar.add(fileMenu);
      openItem = new JMenuItem("Open");
      openItem.setMnemonic (KeyEvent.VK_O);
      openItem.addActionListener(this);
      fileMenu.add(openItem);
      exitItem = new JMenuItem("Exit");
      exitItem.addActionListener(this);
      fileMenu.add(exitItem);
      JMenu windowMenu = new JMenu("Window");
      menuBar.add(windowMenu);
      nextItem = new JMenuItem("Next");
      nextItem.addActionListener(this);
      windowMenu.add(nextItem);
      cascadeItem = new JMenuItem("Cascade");
      cascadeItem.addActionListener(this);
      windowMenu.add(cascadeItem);
      tileItem = new JMenuItem("Tile");
      tileItem.addActionListener(this);
      windowMenu.add(tileItem);
      dragOutlineItem = new JCheckBoxMenuItem("Drag Outline");
      dragOutlineItem.addActionListener(this);
      windowMenu.add(dragOutlineItem);

      JMenu viewMenu = new JMenu("View");
	  viewMenu.setMnemonic (KeyEvent.VK_V);
	  menuBar.add(viewMenu);
	  showTabItem = new JMenuItem("Show Dock/Float Tabbed Window");
	  hideTabItem = new JMenuItem("Hide Dock/Float Tabbed Window");
	  showTreeItem = new JMenuItem("Show Dock/Float Tree Window");
	  hideTreeItem = new JMenuItem("Hide Dock/Float Tree Window");
	  showTextAreaItem = new JMenuItem("Show Dock/Float Text Area Window");
	  hideTextAreaItem = new JMenuItem("Hide Dock/Float Text Area Window");

	  showTabItem.addActionListener(this);
	  hideTabItem.addActionListener(this);
	  showTreeItem.addActionListener(this);
	  hideTreeItem.addActionListener(this);
	  showTextAreaItem.addActionListener(this);
	  hideTextAreaItem.addActionListener(this);

	  viewMenu.add(showTabItem);
	  viewMenu.add(hideTabItem);
	  viewMenu.add(showTreeItem);
	  viewMenu.add(hideTreeItem);
	  viewMenu.add(showTextAreaItem);
	  viewMenu.add(hideTextAreaItem);
	   f.setMenuBar(menuBar);
	     
	   f.initStates(1);  
    //       viewMenu.repaint();
           System.out.println("Menu Position "+f.getBounds());
      

   }


 // Create a dock & float window that contains a JTree component
    private void createDockFloatTreeWindow()
	{

		DefaultMutableTreeNode root
			= new DefaultMutableTreeNode("JDockFloatPro");
		DefaultMutableTreeNode dfframe
			 = new DefaultMutableTreeNode("DockFloatFrame");
		root.add(dfframe);
		DefaultMutableTreeNode dfmenubar
			 = new DefaultMutableTreeNode("DockFloatMenuBar");
		root.add(dfmenubar);
		DefaultMutableTreeNode dftoolbar
			 = new DefaultMutableTreeNode("DockFloatToolBar");
		root.add(dftoolbar);
		dftoolbar = new DefaultMutableTreeNode("DockFloatToolMenuBar");
		root.add(dftoolbar);
		dftoolbar = new DefaultMutableTreeNode("DockFloatWindow");
		root.add(dftoolbar);
	
		// construct tree and put it in a scroll pane

		JTree tree = new JTree(root);
		JScrollPane js=new JScrollPane(tree);

	    dfTreeWindow=new DockFloatWindow(this,"Classes");
	    dfTreeWindow.setSize(100,50);
	    dfTreeWindow.add("Center",js);
	    dfTreeWindow.initStates(0);

	 }


  ////////////////////////////////
  //All following codes are not related to JDockFloatPro.
  //All codes are used to produce MDI desktop panes
   
   public void createInternalFrame(Component c, String t)
   {  JInternalFrame iframe = new JInternalFrame(t,
         true, // resizable
         true, // closable
         true, // maximizable
         true); // iconifiable

      iframe.getContentPane().add(c);
      desktop.add(iframe);

      iframe.setFrameIcon(new ImageIcon("document.gif"));

      // add listener to confirm frame closing
      //iframe.addVetoableChangeListener(this);
     // iframe.addVetoableChangeListener(new Veto());
      System.out.println(" Me Called");

      // position frame
      int width = desktop.getWidth() / 2;
      int height = desktop.getHeight() / 2;
      iframe.reshape(nextFrameX, nextFrameY, width, height);

      iframe.show();

      // select the frame--might be vetoed
      try
      {  iframe.setSelected(true);
      }
      catch(PropertyVetoException e)
      {}

      /* if this is the first time, compute distance between
         cascaded frames
      */

      if (frameDistance == 0)
         frameDistance = iframe.getHeight()
            - iframe.getContentPane().getHeight();

      // compute placement for next frame

      nextFrameX += frameDistance;
      nextFrameY += frameDistance;
      if (nextFrameX + width > desktop.getWidth())
         nextFrameX = 0;
      if (nextFrameY + height > desktop.getHeight())
         nextFrameY = 0;
   }

   public void cascadeWindows()
   {  JInternalFrame[] frames = desktop.getAllFrames();
      int x = 0;
      int y = 0;
      int width = desktop.getWidth() / 2;
      int height = desktop.getHeight() / 2;

      for (int i = 0; i < frames.length; i++)
      {  if (!frames[i].isIcon())
         {  try
            {  /* try to make maximized frames resizable
                  this might be vetoed
               */
               frames[i].setMaximum(false);
               frames[i].reshape(x, y, width, height);

               x += frameDistance;
               y += frameDistance;
               // wrap around at the desktop edge
               if (x + width > desktop.getWidth()) x = 0;
               if (y + height > desktop.getHeight()) y = 0;
            }
            catch(PropertyVetoException e)
            {}
         }
      }
   }

   public void tileWindows()
   {  JInternalFrame[] frames = desktop.getAllFrames();

      // count frames that aren't iconized
      int frameCount = 0;
      for (int i = 0; i < frames.length; i++)
      {  if (!frames[i].isIcon())
            frameCount++;
      }

      int rows = (int)Math.sqrt(frameCount);
	  if(rows<=0)
		 return;
      int cols = frameCount / rows;
	  if(cols<=0)
	     return;
      int extra = frameCount % rows;
         // number of columns with an extra row

      int width = desktop.getWidth() / cols;
      int height = desktop.getHeight() / rows;
      int r = 0;
      int c = 0;
      for (int i = 0; i < frames.length; i++)
      {  if (!frames[i].isIcon())
         {  try
            {  frames[i].setMaximum(false);
               frames[i].reshape(c * width,
                  r * height, width, height);
               r++;
               if (r == rows)
               {  r = 0;
                  c++;
                  if (c == cols - extra)
                  {  // start adding an extra row
                     rows++;
                     height = desktop.getHeight() / rows;
                  }
               }
            }
            catch(PropertyVetoException e)
            {}
         }
      }
   }

   public void selectNextWindow()
   {  JInternalFrame[] frames = desktop.getAllFrames();
      for (int i = 0; i < frames.length; i++)
      {  if (frames[i].isSelected())
         {  /* find next frame that isn't an icon and can be
               selected
            */
            try
            {  int next = i + 1;
               while (next != i && frames[next].isIcon())
                  next++;
               if (next == i) return;
                  // all other frames are icons or veto selection
               frames[next].setSelected(true);
               frames[next].toFront();
               return;
            }
            catch(PropertyVetoException e)
            {}
         }
      }
   }

  

   public Component createEditorPane(URL u)
   {  // create an editor pane that follows hyperlink clicks

      JEditorPane editorPane = new JEditorPane();
      editorPane.setEditable(false);
      editorPane.addHyperlinkListener(new HyperlinkListener()
         {  public void hyperlinkUpdate(HyperlinkEvent event)
            {  createInternalFrame(createEditorPane(event.getURL()),
                  event.getURL().toString());
            }
         });
      try
      {  editorPane.setPage(u);
      }
      catch(IOException e)
      {  editorPane.setText("Error: " + e);
      }
      return new JScrollPane(editorPane);
   }

   public void actionPerformed(ActionEvent evt)
   {
	 //  repaint();

     Object source = evt.getSource();
      if (source == openItem)
      {  // let user select file

         JFileChooser chooser = new JFileChooser();
         chooser.setCurrentDirectory(new File("."));
         chooser.setFileFilter(
            new javax.swing.filechooser.FileFilter()
            {  public boolean accept(File f)
               {  String fname = f.getName().toLowerCase();
                  return fname.endsWith(".html")
                     || fname.endsWith(".htm")
                     || f.isDirectory();
               }
               public String getDescription()
               { return "HTML Files"; }
            });
         int r = chooser.showOpenDialog(this);

         if (r == JFileChooser.APPROVE_OPTION)
         {  // open the file that the user selected

            String filename = chooser.getSelectedFile().getPath();
            try
            {  URL fileUrl = new URL("file:" + filename);
               createInternalFrame(createEditorPane(fileUrl),
                  filename);
            }
            catch(MalformedURLException e)
            {
            }
         }
      }
      else if (source == exitItem)
         System.exit(0);
      else if (source == nextItem)
         selectNextWindow();
      else if (source == cascadeItem)
         cascadeWindows();
      else if (source == tileItem)
         tileWindows();
      else if (source == dragOutlineItem)
      {  desktop.putClientProperty("JDesktopPane.dragMode",
            dragOutlineItem.isSelected() ? "outline" : null);
      }
	  else if( source == showTabItem)
	  {
	     dfTabWindow.setVisible(true);
	  }
	  else if( source == hideTabItem)
	  {
	     dfTabWindow.setVisible(false);
	  }
	  else if( source == showTreeItem)
	  {
	    // dfTreeWindow.setVisible(true);
		dfTreeWindow.unload(true);
	  }
	  else if( source == hideTreeItem)
	  {
	     dfTreeWindow.setVisible(false);
	  }
	  else if( source == showTextAreaItem)
	  {
		 dfTextAreaWindow.setVisible(true);
	  }
	  else if( source == hideTextAreaItem)
	  {
	     dfTextAreaWindow.setVisible(false);
	  }
   }



   protected JMenuBar menuBar;
   private dsx.JDockFloatPro.DockFloatToolBar dfTabWindow;
   private dsx.JDockFloatPro.DockFloatWindow dfTreeWindow;
   private dsx.JDockFloatPro.DockFloatWindow dfTextAreaWindow;
   
   private JDesktopPane desktop;

   private JMenuItem openItem;
   private JMenuItem exitItem;
   private JMenuItem nextItem;
   private JMenuItem cascadeItem;
   private JMenuItem tileItem;
   private JMenuItem dragOutlineItem;

   private JMenuItem showTabItem;
   private JMenuItem hideTabItem;
   private JMenuItem showTreeItem;
   private JMenuItem hideTreeItem;
   private JMenuItem showTextAreaItem;
   private JMenuItem hideTextAreaItem;

   private int nextFrameX;
   private int nextFrameY;
   private int frameDistance;
   
   
   protected class Veto implements VetoableChangeListener
   {
        public void vetoableChange(PropertyChangeEvent event)
      throws PropertyVetoException
   {  JInternalFrame iframe = (JInternalFrame)event.getSource();
      String name = event.getPropertyName();
      Object value = event.getNewValue();

      // we only want to check attempts to close a frame

      if (name.equals("closed") && value.equals(Boolean.TRUE))
      {  // ask user if it is ok to close
         int result
            = JOptionPane.showInternalConfirmDialog(iframe,
               "OK to close?");

         // if the user doesn't agree, veto the close
         if (result == JOptionPane.CANCEL_OPTION)
            throw new PropertyVetoException("User canceled close",
               event);
      }
   }
   }

  
}